%%% File    : user_pl.erl
%%% Author  : Robert Virding
%%% Purpose : Test compilation of Erlog procedures.
%%%
%%% (C)Robert Virding. This stuff is mine, distributed without
%%% warranty "as is" and may not be used commercially without written
%%% permission.
%%% 
%%% Hand compiled app/3 and rev/2 (only forwards) to test speed-up. (~4)

-module(user_pl).

-export([app_3/5,rev_2/5]).

-compile(export_all).

%% app_3(Head, NextGoal, Bindings, VarNum, Database) ->
%%	{succeed,NewBindings,NewVarNum,NewDatabase} | {fail,NewDatabase}.
%% app([], L, L).
%% app([H|T], L, [H|L1]) :- app(T, L, L1).

app_3(Head0, Next0, Bs0, Vn0, Db) ->
    case erlog_int:deref_all(Head0, Bs0) of
	{app,[],A2,A3} ->
	    erlog_int:unify_prove_body(A2, A3, Next0, Bs0, Vn0, Db);
	{app,[H|T],A2,A3} ->
	    L = A2,
	    L1 = {Vn0+1},
	    Next1 = {',',{app,T,L,L1},Next0},
	    erlog_int:unify_prove_body(A3, [H|L1], Next1, Bs0, Vn0+1, Db);
	{app,{_}=A1,A2,A3} ->
	    case begin
		     Bs1 = erlog_int:add_binding(A1, [], Bs0),
		     erlog_int:unify_prove_body(A2, A3, Next0, Bs1, Vn0, Db)
		 end of
		{fail,Db1} ->
		    H = {Vn0},
		    T = {Vn0+1},
		    L = A2,
		    L1 = {Vn0+2},
		    Bs2 = erlog_int:add_binding(A1, [H|T], Bs0),
		    Next1 = {',',{app,T,L,L1},Next0},
		    erlog_int:unify_prove_body(A3, [H|L1],
					       Next1, Bs2, Vn0+3, Db1);
		Succeed ->
		    Succeed
	    end;
	{app,_A1,_A2,_A3} -> {fail,Db}
    end.

%% rev_2(Head, NextGoal, Bindings, VarNum, Database) ->
%%	{succeed,NewBindings,NewVarNum,NewDatabase} | {fail,NewDatabase}.
%% rev([], []).
%% rev([H|T], L1) :- rev(T, L), app(L, [H], L1).

rev_2(Head0, Next0, Bs0, Vn0, Db) ->
    case erlog_int:deref_all(Head0, Bs0) of
	{rev,[],[]} -> erlog_int:prove_body(Next0, Bs0, Vn0, Db);
	{rev,[],{_}=Var} ->
	    Bs1 = erlog_int:add_binding(Var, [], Bs0),
	    erlog_int:prove_body(Next0, Bs1, Vn0, Db);
	{rev,[],_} -> {fail,Db};
	{rev,[H|T],A2} ->
	    L = {Vn0},
	    L1 = A2,
	    Next1 = {',',{rev,T,L},{',',{app,L,[H],L1},Next0}},
	    erlog_int:prove_body(Next1, Bs0, Vn0+1, Db);
	{rev,_A1,_A2} ->
	    {fail,Db}
    end.
